/******************************************************************************
 *	file.c:		t@C̏֐
 ******************************************************************************
 *	Workroom SX-68K Sample Program Copyright 1994 SHARP
 */
#include <stdio.h>
#include <string.h>
#include <doslib.h>
#include <event.h>		/* Cxg}𗘗pƂɕKv	*/
#include <dialog.h>		/* _CAO}𗘗pƂɕKv	*/
#include <task.h>		/* ^XN}𗘗pƂɕKv	*/
#include "file.h"		/* ̃vOŗL̃wb_t@C	*/

/******************************************************************************
 *	copyProc():	Rs[_CAȌ
 ******************************************************************************
 *	:	ComVal *pcv	ʕϐւ̃|C^
 *	߂l:	BOOLEAN		= TRUE:  Rs[
 *				= FALSE: Rs[s
 */
BOOLEAN copyProc(ComVal *pcv)
{
	int num, errCode, len, stat;
	DlgPrm dp = {			/* _CAOpp[^	*/
		2, 16,
		"t@C̃Rs[",
		"Rs[t@C",
		"Rs[t@C"
	};

	num = dialogProc(pcv, &dp);
	if (num == 1) {			/* [s]{^H		*/
		/* Rs[t@C`FbN */
		errCode = checkDrive(pcv, (char *) &dp.src[1], 1);
		if (errCode < 0) {
			if (errCode == -4) /* t@C݂ȂH	*/
				pcv->errorCode = -2;
			return FALSE;
		}

		/* Rs[t@C`FbN */
		errCode = checkDrive(pcv, (char *) &dp.dst[1], 1);
		if (errCode >= 0) {	/* t@C݂邩H	*/
			num = DMError(D_EXEC, "̃t@C݂܂B\r"
					      "㏑܂H");
			if (num == 2)
				return TRUE;

		} else if (errCode == -4)
			errCode = 0;
		else
			return FALSE;

		/* Rs[ƃRs[̃t@CꂩH */
		len = (dp.src[0] >= dp.dst[0]) ? dp.src[0] : dp.dst[0];
		stat = SXStrCmp((char *) &dp.src[1], (char *) &dp.dst[1], len);
		if (stat == 0) {
			 /* t@CփRs[悤Ƃ */
			pcv->errorCode = -22;
			return FALSE;
		}
		/* ҂Ԃ}EX|C^\ */
		EMEnCross();
		/* Rs[ */
		errCode = TSCopyP((char *) &dp.src[1], (char *) &dp.dst[1]);
		/* ҂Ԃ}EX|C^ɖ߂ */
		EMDeCross();
		if (errCode < 0) {
			pcv->errorCode = errCode;
			return FALSE;
		}
	}
	return TRUE;
}

/******************************************************************************
 *	renameProc():	t@CύX̏
 ******************************************************************************
 *	:	ComVal *pcv	ʕϐւ̃|C^
 *	߂l:	BOOLEAN		= TRUE:  t@CύX
 *				= FALSE: t@CύXs
 */
BOOLEAN renameProc(ComVal *pcv)
{
	int num, errCode;
	DlgPrm dp = {			/* _CAOpp[^	*/
		2, 14,
		"t@CύX",
		"ύXt@C",
		"VKt@C"
	};

	num = dialogProc(pcv, &dp);
	if (num == 1) {
		/* [s]{^ŏI */
		/* ύXt@C`FbN */
		errCode = checkDrive(pcv, (char *) &dp.src[1], 1);
		if (errCode < 0) {
			if (errCode == -4)
				/* t@C݂Ȃꍇ͏I */
				pcv->errorCode = -2;
			return FALSE;
		}

		/* VKt@C`FbN */
		errCode = checkDrive(pcv, (char *) &dp.dst[1], 1);
		if (errCode >= 0) {
			/* t@C݂ */
			pcv->errorCode = -22;
			return FALSE;

		} else if (errCode == -4)
			errCode = 0;
		else
			return FALSE;

		/* ҂Ԃ}EX|C^\ */
		EMEnCross();
		/* OύX */
		errCode = TSMoveP((char *) &dp.src[1], (char *) &dp.dst[1]);
		/* ҂Ԃ}EX|C^ɖ߂ */
		EMDeCross();
		if (errCode < 0) {
			pcv->errorCode = errCode;
			return FALSE;
		}
	}
	return TRUE;
}

/******************************************************************************
 *	deleteProc():	t@C폜̏
 ******************************************************************************
 *	:	ComVal *pcv	ʕϐւ̃|C^
 *	߂l:	BOOLEAN		= TRUE:  t@C폜
 *				= FALSE: t@C폜s
 */
BOOLEAN deleteProc(ComVal *pcv)
{
	int num, errCode;
	char str[64];
	char drv[2], path[65], node[19], ext[5];
	DlgPrm dp = {			/* _CAOpp[^	*/
		1, 12,
		"t@C폜",
		"폜t@C"
	};

	num = dialogProc(pcv, &dp);
	if (num == 1) {
		/* [s]{^ŏI */
		/* ύXt@C`FbN */
		errCode = checkDrive(pcv, (char *) &dp.src[1], 1);
		if (errCode < 0) {
			if (errCode == -4)
				/* t@C݂Ȃꍇ͏I */
				pcv->errorCode = -2;
			return FALSE;
		}

		/* tpXt@Co */
		strsfn((char *) &dp.src[1], drv, path, node, ext);
		sprintf(str, "t@C %s.%s\r폜܂B\0", node, ext);
		/* t@C̍폜̊mF */
		num = DMError(D_EXEC, str);
		if (num == 2)
			return TRUE;

		/* ҂Ԃ}EX|C^\ */
		EMEnCross();
		/* t@C폜 */
		errCode = TSDeleteP((char *) &dp.src[1]);
		/* ҂Ԃ}EX|C^ɖ߂ */
		EMDeCross();
		if (errCode < 0) {
			pcv->errorCode = errCode;
			return FALSE;
		}
	}
	return TRUE;
}

/******************************************************************************
 *	mkdirProc():	fBNg쐬̏
 ******************************************************************************
 *	:	ComVal *pcv	ʕϐւ̃|C^
 *	߂l:	BOOLEAN		= TRUE:  fBNg쐬
 *				= FALSE: fBNg쐬s
 */
BOOLEAN mkdirProc(ComVal *pcv)
{
	int num, errCode;
	DlgPrm dp = {			/* _CAOpp[^	*/
		1, 16,
		"fBNg쐬",
		"fBNg"
	};

	num = dialogProc(pcv, &dp);
	if (num == 1) {
		/* [s]{^ŏI */
		/* fBNg`FbN */
		errCode = checkDrive(pcv, (char *) &dp.src[1], 0x80 + 1);
		if (errCode >= 0) {
			/* fBNg݂ꍇ͏I */
			pcv->errorCode = -20;
			return FALSE;

		} else if (errCode == -4)
			errCode = 0;
		else
			/* ̑̃G[ */
			return FALSE;

		/* ҂Ԃ}EX|C^\ */
		EMEnCross();
		/* fBNg쐬 */
		errCode = TSMkDirP((char *) &dp.src[1]);
		/* ҂Ԃ}EX|C^ɖ߂ */
		EMDeCross();
		if (errCode < 0) {
			pcv->errorCode = errCode;
			return FALSE;
		}
	}
	return TRUE;
}

/******************************************************************************
 *	rmdirProc():	fBNg폜̏
 ******************************************************************************
 *	:	ComVal *pcv	ʕϐւ̃|C^
 *	߂l:	BOOLEAN		= TRUE:  fBNg폜
 *				= FALSE: fBNg폜s
 */
BOOLEAN rmdirProc(ComVal *pcv)
{
	int num, errCode;
	char str[64];
	char drv[2], path[65], node[19], ext[5];
	DlgPrm dp = {			/* _CAOpp[^	*/
		1, 16,
		"fBNg폜",
		"fBNg"
	};

	num = dialogProc(pcv, &dp);
	if (num == 1) {
		/* [s]{^ŏI */
		/* fBNg`FbN */
		errCode = checkDrive(pcv, (char *) &dp.src[1], 0x80 + 1);
		if (errCode < 0) {
			if (errCode == -4)
				/* fBNg݂Ȃꍇ͏I */
				pcv->errorCode = -3;
			return FALSE;
		}

		/* tpXt@Co */
		strsfn((char *) &dp.src[1], drv, path, node, ext);
		sprintf(str, "fBNg %s\r폜܂B\0", node);
		/* t@C̍폜̊mF */
		num = DMError(D_EXEC, str);
		if (num == 2)
			return TRUE;

		/* ҂Ԃ}EX|C^\ */
		EMEnCross();
		/* fBNg폜 */
		errCode = TSRmDirP((char *) &dp.src[1]);
		/* ҂Ԃ}EX|C^ɖ߂ */
		EMDeCross();
		if (errCode < 0) {
			pcv->errorCode = errCode;
			return FALSE;
		}
	}
	return TRUE;
}

/******************************************************************************
 *	checkDrive():	wt@C̃hCu`FbN
 ******************************************************************************
 *	:	ComVal *pcv	ʕϐւ̃|C^
 *		char *fname	t@Cւ̃|C^
 *		int mode	郂[hi+0x80 ŁAfBNǧj
 *				=  0: 
 *				=  1: ǂݍ
 *	߂l:	int		>= 0: ǂݍݐ
 *				= -1: t@CȂ
 *				= -2: hCȕłĂȂ
 *				= -3: ݋֎~Ă
 *				= -4: t@C݂Ȃ
 */
int checkDrive(ComVal *pcv, char *fname, int mode)
{
	int att, stat, errCode;
	struct NAMECKBUF nminf;
	struct FILBUF filbuf;		/* t@C			*/

	/* fBNgƂă`FbN邩H */
	att = (mode & 0x80) ? TS_SUBDIR : TS_ARCH;
	mode &= 1;
	/* ͂ꂽt@C𕪉E */
	stat = NAMECK((unsigned char *) fname, &nminf);
	if (stat != 0) {
		pcv->errorCode = -13;	/* t@CȂ	*/
		return -1;
	}
	/* tpX쐬 */
	strmfn(fname, (char *) nminf.drive, (char *) nminf.path, (char *) nminf.name, (char *) nminf.ext);

	/* wt@C̃hCȕԂ擾 */
	stat = TSDrvctrl(0, nminf.drive[0] & 0x1f);
	if ((stat & 0x06) != 0x02) {	/* hCuĂ邩H	*/
		pcv->errorCode = 15;	/* łĂȂ		*/
		return -2;
	}
	/* CgveNgĂ邩H */
	if (mode == 0 && (stat & 0x0a) == 0x0a) {
		pcv->errorCode = 16;	/* veNgĂ		*/
		return -3;
	}
	/* t@C݂̑̃`FbN */
	errCode = TSFiles(&filbuf, fname, att);
	if (errCode < 0)
		/* t@C̐VK쐬ꍇlāA
		   G[_CAO͏oȂ */
		return -4;

	return 0;
}
